git-merge-one-file.shon commit merge-one-file: remove empty directories (397c766)
   1#!/bin/sh
   2#
   3# Copyright (c) Linus Torvalds, 2005
   4#
   5# This is the git per-file merge script, called with
   6#
   7#   $1 - original file SHA1 (or empty)
   8#   $2 - file in branch1 SHA1 (or empty)
   9#   $3 - file in branch2 SHA1 (or empty)
  10#   $4 - pathname in repository
  11#   $5 - orignal file mode (or empty)
  12#   $6 - file in branch1 mode (or empty)
  13#   $7 - file in branch2 mode (or empty)
  14#
  15# Handle some trivial cases.. The _really_ trivial cases have
  16# been handled already by git-read-tree, but that one doesn't
  17# do any merges that might change the tree layout.
  18
  19case "${1:-.}${2:-.}${3:-.}" in
  20#
  21# Deleted in both or deleted in one and unchanged in the other
  22#
  23"$1.." | "$1.$1" | "$1$1.")
  24        if [ "$2" ]; then
  25                echo "Removing $4"
  26        fi
  27        if test -f "$4"; then
  28                rm -f -- "$4" &&
  29                dn="$4" &&
  30                while dn=$(expr "$dn" : '\(.*\)/') && rmdir "$dn" 2>/dev/null
  31                do
  32                        :;
  33                done
  34        fi &&
  35                exec git-update-index --remove -- "$4"
  36        ;;
  37
  38#
  39# Added in one.
  40#
  41".$2." | "..$3" )
  42        echo "Adding $4"
  43        git-update-index --add --cacheinfo "$6$7" "$2$3" "$4" &&
  44                exec git-checkout-index -u -f -- "$4"
  45        ;;
  46
  47#
  48# Added in both, identically (check for same permissions).
  49#
  50".$3$2")
  51        if [ "$6" != "$7" ]; then
  52                echo "ERROR: File $4 added identically in both branches,"
  53                echo "ERROR: but permissions conflict $6->$7."
  54                exit 1
  55        fi
  56        echo "Adding $4"
  57        git-update-index --add --cacheinfo "$6" "$2" "$4" &&
  58                exec git-checkout-index -u -f -- "$4"
  59        ;;
  60
  61#
  62# Modified in both, but differently.
  63#
  64"$1$2$3" | ".$2$3")
  65        src2=`git-unpack-file $3`
  66        case "$1" in
  67        '')
  68                echo "Added $4 in both, but differently."
  69                # This extracts OUR file in $orig, and uses git-apply to
  70                # remove lines that are unique to ours.
  71                orig=`git-unpack-file $2`
  72                sz0=`wc -c <"$orig"`
  73                diff -u -La/$orig -Lb/$orig $orig $src2 | git-apply --no-add 
  74                sz1=`wc -c <"$orig"`
  75
  76                # If we do not have enough common material, it is not
  77                # worth trying two-file merge using common subsections.
  78                expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
  79                ;;
  80        *)
  81                echo "Auto-merging $4."
  82                orig=`git-unpack-file $1`
  83                ;;
  84        esac
  85
  86        # We reset the index to the first branch, making
  87        # git-diff-file useful
  88        git-update-index --add --cacheinfo "$6" "$2" "$4"
  89                git-checkout-index -u -f -- "$4" &&
  90                merge "$4" "$orig" "$src2"
  91        ret=$?
  92        rm -f -- "$orig" "$src2"
  93
  94        if [ "$6" != "$7" ]; then
  95                echo "ERROR: Permissions conflict: $5->$6,$7."
  96                ret=1
  97        fi
  98        if [ "$1" = '' ]; then
  99                ret=1
 100        fi
 101
 102        if [ $ret -ne 0 ]; then
 103                echo "ERROR: Merge conflict in $4."
 104                exit 1
 105        fi
 106        exec git-update-index -- "$4"
 107        ;;
 108
 109*)
 110        echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
 111        ;;
 112esac
 113exit 1